Option Strict Off
Option Explicit On
Imports System.Runtime.InteropServices
Imports System.Text

Friend Class Form1
 Inherits System.Windows.Forms.Form

' **************************  NOTES *********************************************************************
'To successfully run the code in this environment make sure that the files RP2005.dll and FTD2XX.dll are both
'located in the folder Path_to_Project\Project_Name\bin. 

'To successfully run the code outside this environment make sure that the files RP2005.dll and FTD2XX.dll are both
'located in the same folder as the executable. 

'We created 2 subroutines each for reading and writing of the board. This allowed us to show how to use the functions
'RP_ReadPort, RP_ReadAll, RP_WritePort and RP_WriteAll. 
' *******************************************************************************************************

    <DllImport("rp2005.dll")> _
           Private Shared Function RP_ListDIO(ByRef NumDevices As Integer, ByVal SNList As StringBuilder, ByVal DscList As StringBuilder) As Integer
    End Function
    <DllImport("rp2005.dll")> _
           Private Shared Function RP_OpenDIO(ByVal SN As String, ByRef hDIO As Integer) As Integer
    End Function
    <DllImport("rp2005.dll")> _
           Private Shared Function RP_ReadPort(ByVal hDIO As Integer, ByVal portNum As Byte, ByRef portData As Byte, ByVal errMsg As StringBuilder) As Integer
    End Function
    <DllImport("rp2005.dll")> _
           Private Shared Function RP_ReadAll(ByVal hDIO As Integer, ByRef ulLP As Integer, ByRef ulHP As Integer, ByVal errMsg As StringBuilder) As Integer
    End Function
    <DllImport("rp2005.dll")> _
           Private Shared Function RP_WriteAll(ByVal hDIO As Integer, ByVal ulLP As Integer, ByVal ulHP As Integer, ByVal errMsg As StringBuilder) As Integer
    End Function
    <DllImport("rp2005.dll")> _
           Private Shared Function RP_WriteAll_SN(ByVal SN As String, ByVal ulLP As Integer, ByVal ulHP As Integer, ByVal errMsg As StringBuilder) As Integer
    End Function
    <DllImport("rp2005.dll")> _
           Private Shared Function RP_WritePort(ByVal hDIO As Integer, ByVal portNum As Byte, ByVal portData As Byte, ByVal errMsg As StringBuilder) As Integer
    End Function
    <DllImport("rp2005.dll")> _
           Private Shared Function RP_CloseDIO(ByVal hDIO As Integer) As Integer
    End Function
    <DllImport("rp2005.dll")> _
           Private Shared Function RP_ReadAll_SN(ByVal SN As String, ByRef ulLP As Integer, ByRef ulHP As Integer, ByVal errMsg As StringBuilder) As Integer
    End Function

    Private Sub Command1_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Command1.Click
      Dim iError As Integer
      Dim iNumDevs As Short
      Dim tmpSNList As StringBuilder
      Dim tmpDscList As StringBuilder
      Dim SNList As String
      Dim DscList As String
      Dim a_strResult As Object
      Dim i As Short

      tmpSNList = New StringBuilder(513)
      tmpDscList = New StringBuilder(1025)
      SNList = New String(vbNullChar, 513)
      DscList = New String(vbNullChar, 1025)

      ' Get the number of boards, the serial numbers
      ' of the boards, and the board descriptions.
      iError = RP_ListDIO(iNumDevs, tmpSNList, tmpDscList)
      If iError = 0 Then

        Text2.Text = CStr(iNumDevs)

        ' split the board serial numbers into an array.
        ' The board serial numbers are delimited by
        ' commas
        SNList = tmpSNList.ToString
        DscList = tmpDscList.ToString

        a_strResult = Split(SNList, ",")

        ComboBox1.Items.Clear()
        ComboBox2.Items.Clear()


        ' Add the serial number string(s) to the
        '"Selected Device" combo box.
        For i = 0 To UBound(a_strResult)
            ComboBox1.Items.Add((a_strResult(i)))
        Next i

        If ComboBox1.Items.Count > 0 Then ComboBox1.SelectedIndex = 0

        ' split the board descriptions into an array.
        ' The board descriptions are delimited by
        ' commas
        a_strResult = Split(DscList, ",")

        ' Add the board description string(s) to the
        '"Device Description" combo box.
        For i = 0 To UBound(a_strResult)
            ComboBox2.Items.Add((a_strResult(i)))
        Next i
        If ComboBox2.Items.Count > 0 Then
            ComboBox2.SelectedIndex = 0
            tbNumInPorts.Text = Val(Mid(ComboBox2.Text, 7, 2)) / 8
            tbNumOutPorts.Text = Val(Mid(ComboBox2.Text, 9, 2)) / 8
        End If
        ShowPorts()
      Else
        Text1.Text = "Error"
      End If

    End Sub

    Private Sub InputPorts_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles InputPorts.Click
      'ReadPorts()
      'ReadAll()
      ReadAllSN()
    End Sub

    Private Sub OutputPorts_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles OutputPorts.Click
      'WriteOutputs()
      'WriteAll()
      WriteAllSN()
    End Sub

    Private Sub ComboBox1_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ComboBox1.SelectedIndexChanged
      If ComboBox2.Items.Count > 0 Then
        ComboBox2.SelectedIndex = ComboBox1.SelectedIndex
        tbNumInPorts.Text = Val(Mid(ComboBox2.Text, 7, 2)) / 8
        tbNumOutPorts.Text = Val(Mid(ComboBox2.Text, 9, 2)) / 8
        ShowPorts()
      End If
    End Sub

    Private Sub ComboBox2_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ComboBox2.SelectedIndexChanged
      If ComboBox1.Items.Count > 0 Then ComboBox1.SelectedIndex = ComboBox2.SelectedIndex
      If ComboBox2.Items.Count > 0 Then
        tbNumInPorts.Text = Val(Mid(ComboBox2.Text, 7, 2)) / 8
        tbNumOutPorts.Text = Val(Mid(ComboBox2.Text, 9, 2)) / 8
        ShowPorts()
      End If
  End Sub
  Private Sub ShowPorts()
    Dim i, j, k As Integer
    Dim NewLoc As Point
    Dim arrInRow() As System.Windows.Forms.Label = {IRL1, IRL2, IRL3, IRL4}
    Dim arrInPuts(,) As System.Windows.Forms.Label = {{B000, B001, B002, B003, B004, B005, B006, B007}, _
                                                      {B010, B011, B012, B013, B014, B015, B016, B017}, _
                                                      {B020, B021, B022, B023, B024, B025, B026, B027}, _
                                                      {B030, B031, B032, B033, B034, B035, B036, B037}}
    Dim arrOutRow() As System.Windows.Forms.Label = {ORL1, ORL2, ORL3, ORL4}
    Dim arrOutPuts(,) As System.Windows.Forms.Label = {{B100, B101, B102, B103, B104, B105, B106, B107}, _
                                                       {B110, B111, B112, B113, B114, B115, B116, B117}, _
                                                       {B120, B121, B122, B123, B124, B125, B126, B127}, _
                                                       {B130, B131, B132, B133, B134, B135, B136, B137}}

    For i = 0 To 3
      For j = 0 To 7
        arrInPuts(i, j).Visible = False
        arrOutPuts(i, j).Visible = False
      Next j
      arrInRow(i).Visible = False
      arrOutRow(i).Visible = False
    Next i
    Label5.Text = "Inputs"

    k = Val(tbNumInPorts.Text)
    If k > 0 Then
    End If
    For i = 0 To k - 1
      For j = 0 To 7
        arrInPuts(i, j).Visible = True
      Next j
      arrInRow(i).Text = "0" & Trim(Str(i))
      arrInRow(i).Visible = True
    Next i

    k = Val(tbNumOutPorts.Text)
    For i = 0 To k - 1
      If i < 4 Then
        For j = 0 To 7
          arrOutPuts(i, j).Visible = True
        Next j
        arrOutRow(i).Visible = True
      Else
        For j = 0 To 7
          arrInPuts(i - 4, j).Visible = True
        Next j
        arrInRow(i - 4).Text = Str(i + 10)
        arrInRow(i - 4).Visible = True
      End If
    Next i

    If k > 4 Then
      Label5.Text = "Outputs"
    End If
  End Sub
  Private Sub SetInputs(ByVal PortArray() As Byte)
    Dim i, j, k As Integer
    Dim arrInPuts(,) As System.Windows.Forms.Label = {{B000, B001, B002, B003, B004, B005, B006, B007}, _
                                                      {B010, B011, B012, B013, B014, B015, B016, B017}, _
                                                      {B020, B021, B022, B023, B024, B025, B026, B027}, _
                                                      {B030, B031, B032, B033, B034, B035, B036, B037}}

    For i = 0 To 3
      For j = 0 To 7
        arrInPuts(i, j).ForeColor = Color.Gray
      Next j
    Next i
    k = Val(tbNumInPorts.Text)
    For i = 0 To k - 1
      For j = 0 To 7
        If ((PortArray(i) >> j) And 1) Then
          arrInPuts(i, j).ForeColor = Color.Gray
        Else
          arrInPuts(i, j).ForeColor = Color.Red
        End If
      Next j
    Next i
  End Sub
  Private Sub SetOutputs(ByVal PortArray() As Byte)
    Dim i, j, k As Integer
    Dim arrOutPuts(,) As System.Windows.Forms.Label = {{B100, B101, B102, B103, B104, B105, B106, B107}, _
                                                       {B110, B111, B112, B113, B114, B115, B116, B117}, _
                                                       {B120, B121, B122, B123, B124, B125, B126, B127}, _
                                                       {B130, B131, B132, B133, B134, B135, B136, B137}}

    For i = 0 To 3
      For j = 0 To 7
        arrOutPuts(i, j).ForeColor = Color.Gray
      Next j
    Next i
    k = Val(tbNumInPorts.Text)
    For i = 0 To k - 1
      For j = 0 To 7
        If ((PortArray(i) >> j) And 1) Then
          arrOutPuts(i, j).ForeColor = Color.Gray
        Else
          arrOutPuts(i, j).ForeColor = Color.Red
        End If
      Next j
    Next i
  End Sub
  Private Sub GetOutputs(ByRef PortArray() As Byte)
    Dim i, j, k As Integer
    Dim mask As Byte
    Dim arrInPuts(,) As System.Windows.Forms.Label = {{B000, B001, B002, B003, B004, B005, B006, B007}, _
                                                      {B010, B011, B012, B013, B014, B015, B016, B017}, _
                                                      {B020, B021, B022, B023, B024, B025, B026, B027}, _
                                                      {B030, B031, B032, B033, B034, B035, B036, B037}}
    Dim arrOutPuts(,) As System.Windows.Forms.Label = {{B100, B101, B102, B103, B104, B105, B106, B107}, _
                                                       {B110, B111, B112, B113, B114, B115, B116, B117}, _
                                                       {B120, B121, B122, B123, B124, B125, B126, B127}, _
                                                       {B130, B131, B132, B133, B134, B135, B136, B137}}
    mask = 1
    For i = 0 To 3
      PortArray(i) = 255
    Next i
    k = Val(tbNumOutPorts.Text)
    For i = 0 To k - 1
      If i < 4 Then
        For j = 0 To 7
          If arrOutPuts(i, j).ForeColor = Color.Red Then
            PortArray(i) = (PortArray(i) And (255 - (mask << j)))
          End If
        Next j
      Else
        For j = 0 To 7
          If arrInPuts(i - 4, j).ForeColor = Color.Red Then
            PortArray(i) = (PortArray(i) And (255 - (mask << j)))
          End If
        Next j
      End If
    Next i
  End Sub
  Private Sub ReadPorts()
    Dim i, j As Integer
    Dim iError As Integer
    Dim InPortArray(3) As Byte
    Dim OutPortArray(3) As Byte
    Dim pval As Byte
    Dim errMsg As StringBuilder
    Dim hDIO As Integer
    Dim SN As String

    If Val(tbNumInPorts.Text) < 1 Then Exit Sub
    SN = New String(vbNullChar, 100)
    errMsg = New StringBuilder(513)
    SN = ComboBox1.SelectedItem.ToString

    iError = RP_OpenDIO(SN, hDIO)
    If (iError = 0) Then
      j = Val(tbNumInPorts.Text)
      For i = 0 To j - 1
        iError = RP_ReadPort(hDIO, i, pval, errMsg)
        If (iError = 0) Then
          InPortArray(i) = pval
        Else
            Text1.Text = errMsg.ToString
            RP_CloseDIO(hDIO)
            Exit Sub
        End If
        iError = RP_ReadPort(hDIO, i + 16, pval, errMsg)
        If (iError = 0) Then
          OutPortArray(i) = pval
        Else
            Text1.Text = errMsg.ToString
            RP_CloseDIO(hDIO)
            Exit Sub
        End If
      Next i
      SetInputs(InPortArray)
      SetOutputs(OutPortArray)
      RP_CloseDIO(hDIO)
    Else
        Text1.Text = "RP_OPENDIO Error"
    End If
  End Sub
  Private Sub ReadAll()
    Dim i As Integer
    Dim iError As Integer
    Dim InPortArray(3) As Byte
    Dim OutPortArray(3) As Byte
    Dim LPort, HPort As Integer
    Dim pval As Byte
    Dim errMsg As StringBuilder
    Dim hDIO As Integer
    Dim SN As String

    If Val(tbNumInPorts.Text) < 1 Then Exit Sub
    SN = New String(vbNullChar, 100)
    errMsg = New StringBuilder(513)
    SN = ComboBox1.SelectedItem.ToString

    iError = RP_OpenDIO(SN, hDIO)
    If (iError = 0) Then
      RP_ReadAll(hDIO, LPort, HPort, errMsg)
      If (iError = 0) Then
        For i = 3 To 0 Step -1
          InPortArray(i) = LPort And &HFF
          OutPortArray(i) = HPort And &HFF
          LPort = LPort >> 8
          HPort = HPort >> 8
        Next i
      Else
        Text1.Text = errMsg.ToString
        RP_CloseDIO(hDIO)
        Exit Sub
      End If
      SetInputs(InPortArray)
      SetOutputs(OutPortArray)
      RP_CloseDIO(hDIO)
    Else
        Text1.Text = "RP_OPENDIO Error"
    End If
  End Sub
  Private Sub ReadAllSN()
    Dim i As Integer
    Dim iError As Integer
    Dim InPortArray(3) As Byte
    Dim OutPortArray(3) As Byte
    Dim LPort, HPort As Integer
    Dim pval As Byte
    Dim errMsg As StringBuilder
    Dim hDIO As Integer
    Dim SN As String

    If Val(tbNumInPorts.Text) < 1 Then Exit Sub
    SN = New String(vbNullChar, 100)
    errMsg = New StringBuilder(513)
    SN = ComboBox1.SelectedItem.ToString

    iError = RP_ReadAll_SN(SN, LPort, HPort, errMsg)
    If (iError = 0) Then
      For i = 3 To 0 Step -1
        InPortArray(i) = LPort And &HFF
        OutPortArray(i) = HPort And &HFF
        LPort = LPort >> 8
        HPort = HPort >> 8
      Next i
      SetInputs(InPortArray)
      SetOutputs(OutPortArray)
    Else
      Text1.Text = errMsg.ToString
    End If
  End Sub
  Private Sub WriteOutputs()
    Dim i, j As Integer
    Dim PortArray() As Byte = {255, 255, 255, 255, 255, 255, 255, 255}
    Dim iError As Integer
    Dim pval As Byte
    Dim errMsg As StringBuilder
    Dim hDIO As Integer
    Dim SN As String

    If Val(tbNumOutPorts.Text) < 1 Then Exit Sub
    SN = New String(vbNullChar, 100)
    errMsg = New StringBuilder(513)
    SN = ComboBox1.SelectedItem.ToString

    iError = RP_OpenDIO(SN, hDIO)
    If (iError = 0) Then
      j = Val(tbNumOutPorts.Text)
      GetOutputs(PortArray)
      For i = 0 To j - 1
        pval = PortArray(i)
        iError = RP_WritePort(hDIO, i + 16, pval, errMsg)
        If (iError = 0) Then
        Else
          Text1.Text = errMsg.ToString
          RP_CloseDIO(hDIO)
          Exit Sub
        End If
      Next i
        RP_CloseDIO(hDIO)
      Else
        Text1.Text = "RP_OPENDIO Error"
      End If
  End Sub
  Private Sub WriteAll()
    Dim i, j As Integer
    Dim PortArray() As Byte = {255, 255, 255, 255, 255, 255, 255, 255}
    Dim iError As Integer
    Dim LPort, HPort As Integer
    Dim errMsg As StringBuilder
    Dim hDIO As Integer
    Dim SN As String

    LPort = &HFFFFFFFF
    HPort = &HFFFFFFFF
    If Val(tbNumOutPorts.Text) < 1 Then Exit Sub
    SN = New String(vbNullChar, 100)
    errMsg = New StringBuilder(513)
    SN = ComboBox1.SelectedItem.ToString

    iError = RP_OpenDIO(SN, hDIO)
    If (iError = 0) Then
      j = Val(tbNumOutPorts.Text)
      GetOutputs(PortArray)
      For i = 0 To 7
        If i < 4 Then
          LPort = LPort << 8
          LPort = LPort + PortArray(i)
        Else
          HPort = HPort << 8
          HPort = HPort + PortArray(i)
        End If
      Next i
      iError = RP_WriteAll(hDIO, LPort, HPort, errMsg)
      If (iError = 0) Then
      Else
        Text1.Text = errMsg.ToString
      End If
     RP_CloseDIO(hDIO)
    Else
      Text1.Text = "RP_OPENDIO Error"
    End If
  End Sub
  Private Sub WriteAllSN()
    Dim i, j As Integer
    Dim PortArray() As Byte = {255, 255, 255, 255, 255, 255, 255, 255}
    Dim iError As Integer
    Dim LPort, HPort As Integer
    Dim errMsg As StringBuilder
    Dim hDIO As Integer
    Dim SN As String

    LPort = &HFFFFFFFF
    HPort = &HFFFFFFFF
    If Val(tbNumOutPorts.Text) < 1 Then Exit Sub
    SN = New String(vbNullChar, 100)
    errMsg = New StringBuilder(513)
    SN = ComboBox1.SelectedItem.ToString

    j = Val(tbNumOutPorts.Text)
    GetOutputs(PortArray)
    For i = 0 To 7
      If i < 4 Then
        LPort = LPort << 8
        LPort = LPort + PortArray(i)
      Else
        HPort = HPort << 8
        HPort = HPort + PortArray(i)
      End If
    Next i
    iError = RP_WriteAll_SN(SN, LPort, HPort, errMsg)
    If (iError = 0) Then
    Else
      Text1.Text = errMsg.ToString
    End If
  End Sub
Private Sub tsmiClearOutputs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiClearOutputs.Click
  Dim i, j, k As Integer
    Dim arrInPuts(,) As System.Windows.Forms.Label = {{B000, B001, B002, B003, B004, B005, B006, B007}, _
                                                      {B010, B011, B012, B013, B014, B015, B016, B017}, _
                                                      {B020, B021, B022, B023, B024, B025, B026, B027}, _
                                                      {B030, B031, B032, B033, B034, B035, B036, B037}}
    Dim arrOutPuts(,) As System.Windows.Forms.Label = {{B100, B101, B102, B103, B104, B105, B106, B107}, _
                                                       {B110, B111, B112, B113, B114, B115, B116, B117}, _
                                                       {B120, B121, B122, B123, B124, B125, B126, B127}, _
                                                       {B130, B131, B132, B133, B134, B135, B136, B137}}

  k = Val(tbNumOutPorts.Text)
  For i = 0 To k - 1
    For j = 0 To 7
      If i < 4 Then
        arrOutPuts(i, j).ForeColor = Color.Gray
      Else
        arrInPuts(i - 4, j).ForeColor = Color.Gray
      End If
    Next j
  Next i
  WriteOutputs()
End Sub

Private Sub tsmiSetAllOutputs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiSetAllOutputs.Click
  Dim i, j, k As Integer
    Dim arrInPuts(,) As System.Windows.Forms.Label = {{B000, B001, B002, B003, B004, B005, B006, B007}, _
                                                      {B010, B011, B012, B013, B014, B015, B016, B017}, _
                                                      {B020, B021, B022, B023, B024, B025, B026, B027}, _
                                                      {B030, B031, B032, B033, B034, B035, B036, B037}}
    Dim arrOutPuts(,) As System.Windows.Forms.Label = {{B100, B101, B102, B103, B104, B105, B106, B107}, _
                                                       {B110, B111, B112, B113, B114, B115, B116, B117}, _
                                                       {B120, B121, B122, B123, B124, B125, B126, B127}, _
                                                       {B130, B131, B132, B133, B134, B135, B136, B137}}

  k = Val(tbNumOutPorts.Text)
  For i = 0 To k - 1
    For j = 0 To 7
      If i < 4 Then
        arrOutPuts(i, j).ForeColor = Color.Red
      Else
        arrInPuts(i - 4, j).ForeColor = Color.Red
      End If
    Next j
  Next i
  WriteAll()
End Sub

Private Sub tsmiSetOddOutputs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiSetOddOutputs.Click
  Dim i, j, k As Integer
    Dim arrInPuts(,) As System.Windows.Forms.Label = {{B000, B001, B002, B003, B004, B005, B006, B007}, _
                                                      {B010, B011, B012, B013, B014, B015, B016, B017}, _
                                                      {B020, B021, B022, B023, B024, B025, B026, B027}, _
                                                      {B030, B031, B032, B033, B034, B035, B036, B037}}
    Dim arrOutPuts(,) As System.Windows.Forms.Label = {{B100, B101, B102, B103, B104, B105, B106, B107}, _
                                                       {B110, B111, B112, B113, B114, B115, B116, B117}, _
                                                       {B120, B121, B122, B123, B124, B125, B126, B127}, _
                                                       {B130, B131, B132, B133, B134, B135, B136, B137}}

  k = Val(tbNumOutPorts.Text)
  For i = 0 To k - 1
    For j = 0 To 7
      If i < 4 Then
        If j Mod 2 Then
          arrOutPuts(i, j).ForeColor = Color.Red
        Else
          arrOutPuts(i, j).ForeColor = Color.Gray
        End If
      Else
        If j Mod 2 Then
          arrInPuts(i - 4, j).ForeColor = Color.Red
        Else
          arrInPuts(i - 4, j).ForeColor = Color.Gray
        End If
      End If
    Next j
  Next i
  WriteOutputs()
End Sub

Private Sub tsmiSetEvenOutputs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiSetEvenOutputs.Click
  Dim i, j, k As Integer
    Dim arrInPuts(,) As System.Windows.Forms.Label = {{B000, B001, B002, B003, B004, B005, B006, B007}, _
                                                      {B010, B011, B012, B013, B014, B015, B016, B017}, _
                                                      {B020, B021, B022, B023, B024, B025, B026, B027}, _
                                                      {B030, B031, B032, B033, B034, B035, B036, B037}}
    Dim arrOutPuts(,) As System.Windows.Forms.Label = {{B100, B101, B102, B103, B104, B105, B106, B107}, _
                                                       {B110, B111, B112, B113, B114, B115, B116, B117}, _
                                                       {B120, B121, B122, B123, B124, B125, B126, B127}, _
                                                       {B130, B131, B132, B133, B134, B135, B136, B137}}

  k = Val(tbNumOutPorts.Text)
  For i = 0 To k - 1
    For j = 0 To 7
      If i < 4 Then
        If j Mod 2 Then
          arrOutPuts(i, j).ForeColor = Color.Gray
        Else
          arrOutPuts(i, j).ForeColor = Color.Red
        End If
      Else
        If j Mod 2 Then
          arrInPuts(i - 4, j).ForeColor = Color.Gray
        Else
          arrInPuts(i - 4, j).ForeColor = Color.Red
        End If
      End If
    Next j
  Next i
  WriteAll()
End Sub
Private Sub MenuStrip1_ItemClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ToolStripItemClickedEventArgs) Handles MenuStrip1.ItemClicked

End Sub
Private Sub B100_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B100.Click, B137.Click, B136.Click, B135.Click, B134.Click, B133.Click, B132.Click, B131.Click, B130.Click, B127.Click, B126.Click, B125.Click, B124.Click, B123.Click, B122.Click, B121.Click, B120.Click, B117.Click, B116.Click, B115.Click, B114.Click, B113.Click, B112.Click, B111.Click, B110.Click, B107.Click, B106.Click, B105.Click, B104.Click, B103.Click, B102.Click, B101.Click
  If sender.ForeColor = Color.Gray Then
    sender.ForeColor = Color.Red
  Else
    sender.ForeColor = Color.Gray
  End If
  WriteAllSN()
End Sub
Private Sub B000_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B000.Click, MyBase.Click, B037.Click, B036.Click, B035.Click, B034.Click, B033.Click, B032.Click, B031.Click, B030.Click, B027.Click, B026.Click, B025.Click, B024.Click, B023.Click, B022.Click, B021.Click, B020.Click, B017.Click, B016.Click, B015.Click, B014.Click, B013.Click, B012.Click, B011.Click, B010.Click, B007.Click, B006.Click, B005.Click, B004.Click, B003.Click, B002.Click, B001.Click
  If Val(tbNumOutPorts.Text) < 5 Then Exit Sub
  If sender.ForeColor = Color.Gray Then
    sender.ForeColor = Color.Red
  Else
    sender.ForeColor = Color.Gray
  End If
  WriteAllSN()
End Sub
End Class